<?php if(!defined('PLX_ROOT')) exit;
/**
 * Plugin	Cmixml @s CKEditor Mix : PluXml 5.2 to 5.8+
 * @version	1.1.1
 * @date	21/07/2020
 * @author	Thomas Ingles
 *
 **/

class Cmixml extends plxPlugin {
	public $v = '1.1.1';//cache css & js
	public $lang;
	public $racine;
	
	/**
	 * Méthode qui supprime un parametre du fichier parameters.xml
	 * @param	param	nom du parametre à supprimer
	 * @return	true si parametre supprimé, false sinon
	 * @author	Sebastien H
	 **/
	public function delParam($param) {//créé dans PluXml-5.4
		if(isset($this->aParams[$param])) {
			unset($this->aParams[$param]);
			return true;
		} else {
			return false;
		}
	}

	/**
	 * Constructeur de la classe Cmixml
	 * @param	default_lang	langue par défaut utilisée par PluXml
	 * @return	null
	 * @authors	Thomas Ingles;
	 **/
	public function __construct($default_lang) {
		$this->addHook('AdminArticleFootadhesionSel', 'AdminFootEndBody');//AdminTopEndHead #bep
		if(defined('PLX_ADMIN') AND !isset($_POST['new_category'])){#Déclaration des hooks pour la zone d'administration
			$this->lang = ( isset($_SESSION['admin_lang'])?$_SESSION['admin_lang'] : (isset($_SESSION['lang'])?$_SESSION['lang']:$default_lang) );//$_SESSION['admin_lang']:plx>=5.6
			parent::__construct($this->lang);//parent::__construct($default_lang);# Appel du constructeur de la classe plxPlugin (obligatoire)
			# droits pour accéder à la page config.php du plugin
			$this->setConfigProfil(PROFIL_ADMIN);

			# répertoire racine d'installation de PluXml sur le serveur
			$dir = str_replace("\\", "/", dirname($_SERVER["SCRIPT_NAME"]));
			$this->racine = trim(preg_replace("/\/(core|plugins)\/(.*)/", "", $dir), "/")."/";
			$this->racine = $this->racine[0]!="/" ? "/".$this->racine : $this->racine;

			if(!!$this->getParam('admin_files_extend') && isset($_SERVER['QUERY_STRING']) && preg_match('/('.$this->getParam('admin_files').')/', basename($_SERVER['SCRIPT_NAME']).'_'.$_SERVER['QUERY_STRING'])) {//
				$this->addHook('ThemeEndBody', 'AdminFootEndBody');
			}//getParam admin_files 1.1

			if(!!$this->getParam('admin_files') && preg_match('/('.$this->getParam('admin_files').')/', basename($_SERVER['SCRIPT_NAME']))) {//
//if(=! url parametres_users.php | parametres_plugins.php){} todo ?not sur ??
				$this->addHook('AdminTopEndHead', 'AdminTopEndHead');
				$this->addHook('AdminFootEndBody', 'AdminFootEndBody');
//			}//getParam admin_files 0.0
//			if(!isset($_POST['new_category'])) {#on top

				if(!empty($_POST)){
					# conversion des liens abs/rel dans les articles, pages statiques, Categories, Profil et Commentaires
					$this->addHook('plxAdminEditArticle', 'urls2Root');
					$this->addHook('plxAdminEditStatique', 'urls2Root');
					$this->addHook('plxAdminEditCategoriesUpdate', 'urls2Root');
					$this->addHook('plxAdminEditProfil', 'urls2Root');
					$this->addHook('plxAdminEditUser', 'urls2Root');
					$this->addHook('plxAdminEditConfiguration', 'urls2Root');//parametres_affichage
					$this->addHook('plxMotorAddCommentaire', 'urls2Root');
				}else{
					# conversion des liens rel/abs dans les articles, pages statiques, Categories, Profil et Commentaires
					$this->addHook('AdminArticleTop', 'toRoot');
					$this->addHook('AdminStaticTop', 'toRoot');
					$this->addHook('AdminCategoryTop', 'toRoot');
					$this->addHook('AdminProfilTop', 'toRoot');
					$this->addHook('AdminUserTop', 'toRoot');
					$this->addHook('AdminSettingsDisplayTop', 'toRoot');
					#AdminCommentTop AdminCommentNewTop (todo)
				}
//				$this->addHook('AdminMediasFoot', 'AdminMediasFoot');#TEP.0.0
//			}//FI !isset $_POST['new_category'] 0.0 (2 IF's)
			}//getParam admin_files 1.0
			$this->addHook('AdminMediasFoot', 'AdminMediasFoot');#TEP.1.0
		}#fi PLX_ADMIN
	}
#todo from gutuma 2.2 + L_NO_JS_STORAGE
	public function AdminMediasFoot(){//changement des onclic target blank en lien retour pour Ck du gestionnaire de médias (popup)
// core/admin/medias.php?type=image&input=content&CKEditor=id_content&CKEditorFuncNum=179&langCode=fr
// core/admin/medias.php?type=image&input=content&CKEditor=id_content&CKEditorFuncNum=0&langCode=fr
//if(!isset($_GET['CKEditor'])) RETURN;#lost get after upload or go to folder
?>
<script type="text/javascript">//console.log(window.parent,window.opener.CKEDITOR);
if (window.opener && window.opener.CKEDITOR){//1 || media manager : gutuma (in compose iframe)
	sessionStorage.setItem('StickyNotes', 'none');//hide StickyNotes plugin notes
	//stackoverflow.com/a/36108449 : onload chained
	if(window.onload != null){var fgfm = window.onload;}
	window.onload=function(){//restore rules
		try{//hide plxAdminBar (from stickyNotes)
			document.getElementById('plxadminbar').style.display = 'none';//hide bar
			new Array('-nocache','-icon','').forEach(function(e){//plxadminbar links
				var ab_css = document.getElementById('plxadminbar'+e+'-css');//link id
				ab_css.parentNode.removeChild(ab_css);//remove
			});
		}catch(e){if(console)console.log('#<?php echo @L_MEDIAS_TITLE . ' : ' . __CLASS__ ?> : hide plxAdminBar error: '+e,e)}
		if(fgfm!=null){fgfm();}//chained onload
	}
	function gu_GetUrlParam(varName, url){//src : roxyfileMan js util.js :  RoxyUtils.GetUrlParam
		var ret = '';
		if(!url)
			url = self.location.href;
		if(url.indexOf('?') > -1){
				url = url.substr(url.indexOf('?') + 1);
				url = url.split('&');
				for(i = 0; i < url.length; i++){
					var tmp = url[i].split('=');
					if(tmp[0] && tmp[1] && tmp[0] == varName){
						ret = tmp[1];
						break;
					}
				}
		}
		return ret;
	}
	function ckeditor(insertPath,input){//src : roxyfileMan js main.js function getPreselectedFile()
		window.opener.CKEDITOR.tools.callFunction(CKEditorFuncNum, insertPath);
		self.close();
	}
//Get for Memory url query &type &input (is needed after upload)
	var	CKEditorFuncNum = gu_GetUrlParam('CKEditorFuncNum'),
		integration = gu_GetUrlParam('integration'),//integration=ckeditor
		editType = gu_GetUrlParam('type'),
		where = gu_GetUrlParam('input');
//	console.log('#000', CKEditorFuncNum, integration, editType, where);
	try{//Fix lost query &type &input after upload
		if(CKEditorFuncNum){
			sessionStorage.<?php echo __CLASS__ ?>CKEditorFuncNum = CKEditorFuncNum;
		}
		else if (sessionStorage.<?php echo __CLASS__ ?>CKEditorFuncNum){
			CKEditorFuncNum = sessionStorage.<?php echo __CLASS__ ?>CKEditorFuncNum;
		}
		if(editType){
			sessionStorage.<?php echo __CLASS__ ?>editType = editType;
		}
		else if (sessionStorage.<?php echo __CLASS__ ?>editType){
			editType = sessionStorage.<?php echo __CLASS__ ?>editType;
		}
		if(integration){
			sessionStorage.<?php echo __CLASS__ ?>integration = integration;
		}
		else if (sessionStorage.<?php echo __CLASS__ ?>integration){
			integration = sessionStorage.<?php echo __CLASS__ ?>integration;
		}
		if(where){//input
			sessionStorage.<?php echo __CLASS__ ?>where = where;
		}
		else if (sessionStorage.<?php echo __CLASS__ ?>where){
			where = sessionStorage.<?php echo __CLASS__ ?>where;
		}
	}catch(e){
		if(console)console.log('SessionStorage error: '+e,e);//fallback
		if(typeof(Storage !== "undefined")){
			if(CKEditorFuncNum){
				localStorage.setItem("<?php echo __CLASS__ ?>CKEditorFuncNum", CKEditorFuncNum);
			}
			else if (localStorage.getItem("<?php echo __CLASS__ ?>CKEditorFuncNum")){
				CKEditorFuncNum = localStorage.getItem("<?php echo __CLASS__ ?>CKEditorFuncNum");
			}
			if(editType){
				localStorage.setItem("<?php echo __CLASS__ ?>editType", editType);
			}
			else if (localStorage.getItem("<?php echo __CLASS__ ?>editType")){
				editType = localStorage.getItem("<?php echo __CLASS__ ?>editType");
			}
			if(integration){
				localStorage.setItem("<?php echo __CLASS__ ?>integration", integration);
			}
			else if (localStorage.getItem("<?php echo __CLASS__ ?>integration")){
				integration = localStorage.getItem("<?php echo __CLASS__ ?>integration");
			}
			if(where){//input
				localStorage.setItem("<?php echo __CLASS__ ?>where", where)
			}
			else if (localStorage.getItem("<?php echo __CLASS__ ?>where")){
				where = localStorage.getItem("<?php echo __CLASS__ ?>where");
			}
			if(console)console.log('Attempt with Storage');
		}else{
			alert('<?php echo @L_MEDIAS_TITLE . ' : ' . __CLASS__ ?> <?php $this->lang('L_NO_JS_STORAGE') ?>');
		}
	}
editType = !!editType?editType:'all';//fix if no editType (flash embed plg
console.log('#000', CKEditorFuncNum, integration, editType, where);
	if(integration){//only if called by ckeditor : browse server btn image (iframe)
		var loca = window.parent.location.href.split('/').pop();
		var body = document.getElementsByTagName('body');
		body = body[0];//body.id="medias";
		body.className="mediasManager";
		var tbody = document.getElementsByTagName('tbody');
		var ancres = tbody[0].getElementsByTagName('a');
		for(var i = 0; i < ancres.length; i++){
			if(ancres[i].getAttribute('onclick')){
				var str = ancres[i].getAttribute('onclick');
				var res = str.substr(0, 4);// this OR over[lay]
				if(res == 'this'){
					var type = 'document';// IDEA : iframe
					if ((/\.(gif|jpg|jpeg|png|svg)$/i).test(ancres[i].href))
						type = 'image';
					else if (/\.(tb)\./i.test(ancres[i].href))
						type = 'image';//thumb
//					else
//						type = 'media';

					else if (/\.(mp3|ogg|wav)/i.test(ancres[i].href))
						type = 'audio';//media
					else if (/\.(mp4|ogv|webm)/i.test(ancres[i].href))
						type = 'video';//media

					if(editType && (editType != type && editType != 'all') ){
						ancres[i].parentElement.parentElement.style.display="none";//hide tr
					}else{
						//~ ancres[i].setAttribute('onclick','tinymce4(this.href,where);return false;')
						ancres[i].setAttribute('onclick','ckeditor(this.href,where);return false;')
						ancres[i].style.color="darkgreen";//gutuma color link
						ancres[i].title = "+ "+ancres[i].title+" > "+loca;
					}
				}
			}
		}// rof ancres
	}// fi editType
}
</script>
<?php
	}

	/**
	 * Méthode qui ajoute la déclaration du script javascript de CKEditor dans la partie <head>
	 * @return	stdio
	 * @author	Thomas Ingles
	 **/
	public function AdminTopEndHead() {
/*
		$string = '
		$_SESSION["FILEMAN_FILES_ROOT"] = "'.$this->racine.trim($this->getParam('folder'), '/').'";
		if($plxAdmin->aConf["userfolders"] AND $_SESSION["profil"]==PROFIL_WRITER) {
			$_SESSION["FILEMAN_FILES_ROOT"] .= "/".$_SESSION["user"];
		}';
		echo '<?php '.$string.' ?>';
*/
?>
<script src="<?php echo PLX_PLUGINS.__CLASS__; ?>/ckeditor/ckeditor.js?v<?php echo $this->v ?>"></script>
<style style="display:none;">
.cke_dialog_contents tr:hover{background-color:#fff;}
.cke_inner.cke_reset.cke_maximized{position:fixed !important;/* Fix too long img on fullscreen */top:0 !important;z-index:1000000!important}/* plxAdminBar2 +10 : OLD : responsive menu plx + 1 (10000)  */
.cke_dialog_background_cover,.cke_notifications_area{z-index:1000001!important}
.cke_dialog_container,.cke_dialog{z-index:1000002!important}
.CodeMirror-wrap{z-index: 0;}/* FIX CodeMirror au dessus .in-action-bar */
a.cke_toolbox_collapser, a.cke_toolbox_collapser.cke_toolbox_collapser_min{margin:0 1px 3px!important;padding:5.5px!important;/* background:rgba(255,255,255,0.255) */}
</style>
<?php
	}

	/**
	 * Fonction qui ajoute la déclaration du script javascript de CKEditor en bas des pages
	 *
	 * @return	stdio
	 * @author	Thomas Ingles
	 **/
	public function AdminFootEndBody() {
		$mode = rtrim(basename($_SERVER['SCRIPT_NAME']),'.php');//statique, article ...
		$extra = trim($this->getParam('extraPlugins'));
		$extraPlugins = ($extra !='' ? ','.$extra : '');
		$extraPlugins = str_replace(' ', '', $extraPlugins);
		$height = trim($this->getParam('height'));
		if($height!='') $height = 'height:'.(is_numeric($height) ? $height : '"'.$height.'"').',';

		$skin = $this->getParam('skin');
		$skin_opt = $skin?$skin:'moono';
		$edit_opt = '';
		$spell_opt = '';
		$edit_tools = $this->getParam('tools');
		$spell_check = $this->getParam('spellcheck');
		if ($spell_check != 'no'){//spellcheck
			$spell_opt = "				disableNativeSpellChecker: false,".PHP_EOL;//true by default
		}
		$edit_opt .= "				toolbarCanCollapse: true,".PHP_EOL;
		switch ($edit_tools){
			case 'hide':
				$edit_opt .= "		toolbarStartupExpanded: false,".PHP_EOL;//hidden tools by default
			case 'open':
				break;
			case 'see':
				$edit_opt = "";//UnCollapsable
		}
 //insert templates of themes/myPersonalTheme/ckeditortemplates
		echo "<?php
		\$editTemplates = false;
		if(\$themeTemplates = is_dir(PLX_ROOT.'themes/'.\$plxAdmin->style.'/ckeditor/'))
			\$themeTemplates = array_diff(scandir(PLX_ROOT.'themes/'.\$plxAdmin->style.'/edit/'), array('.', '..'));
		if(\$themeTemplates){
			\$editTemplates = '
			[';
			foreach(\$themeTemplates as \$editTemplate ){
				\$editTemplates .= '
				{\"title\": \"'.plxUtils::strCheck(\$editTemplate).'\", \"description\": \"'.plxUtils::strCheck(\$editTemplate).'\", \"url\": \"'.PLX_ROOT.'themes/'.\$plxAdmin->style.'/edit/'.plxUtils::strCheck(\$editTemplate).'\"}';
			\$editTemplates .= '
			]';
			}
		}
		?>";

$toolbarGroups = "
				toolbarGroups: [
					{ name: 'document',	groups: [ 'tools', 'document' ] },
".($_SESSION['profil']<PROFIL_MODERATOR?"					{ name: 'admin',	groups: [ 'mode', 'doctools' ] },":'')."
					{ name: 'board',	groups: [ 'clipboard', 'undo', 'find', 'selection' ] },
					{ name: 'editing',	groups: [ 'links', 'insert', 'others'] },
".(($mode=='statique' OR $mode=='parametres_edittpl')?"					{ name: 'forms' },":'')."
							'/',
					{ name: 'paragraph',	groups: [ 'br', 'list', 'align', 'basicstyles' ] },
					{ name: 'style',	groups: [ 'styles', 'colors', 'cleanup' ] }
				],".PHP_EOL;
?>
<script type="text/javascript">
if(typeof CKEDITOR != 'undefined') {
	var is_modified = 0;
	var editor = new Array();
	//~ var roxyFileman = '<?php echo PLX_PLUGINS.__CLASS__ ?>/fileman/index.html?integration=ckeditor';
	var <?php echo __CLASS__ ?>Fileman = '<?php echo plxUtils::getRacine() ?>core/admin/medias.php?integration=ckeditor';//

function ckToggleEditor(id) {
// console.log('ckToggleEditor(id)',id,CKEDITOR.instances);
/*
for(var i in CKEDITOR.instances) {
  console.log('each',i,CKEDITORAPI.GetInstance(i));

	}
*/

	var ta = document.getElementById(id);//textarea
	//~ var ck = document.getElementById('cke_'+id);//.ckeditorGet();//;//editeur
	//~ console.log('ckToggleEditor(ck)',ck,ck.style.display);//editeur
//	console.log('ckToggleEditor(ta)',ta,ta.style.display);//textarea
	if(ta.style.display == 'none'){
//		console.log('ckToggleEditor(id) OFF',id);
//		console.log('CKEDITOR.instances',CKEDITOR.instances[id]);
		CKEDITOR.instances[id].destroy()
	}else{
//		console.log('ckToggleEditor(id) ON',id);
		ckeInit(id);//CKEDITOR.replace(id); one with opts
	}
}


function ckeInit(taid) {
/*
CKEDITOR.editorConfig = function( config ) {//no
	// Define changes to default configuration here. For example:
	// config.language = 'fr';
	// config.uiColor = '#AADC6E';
	//config.protectedSource.push( /<\?php [\s\S]*?\?>/g );//ok
};
*/
// console.log('ckeInit(taid)',taid);
	//~ var textareas = taid?document.getElementById(taid):document.getElementsByTagName("textarea");
	var textareas = document.getElementsByTagName("textarea");
	for(var i=0;i<textareas.length;i++) {
		var n = textareas[i].name;
		if(n=="content" || n=="chapo") {

if(taid && taid != 'id_'+n) continue;//toggle only one (2nd time)
// console.log('textarea height '+i,textareas[i].offsetHeight);
//ckeditor.com/docs/ckeditor4/latest/api/CKEDITOR_config.html#cfg-toolbarStartupExpanded
			editor[i] = CKEDITOR.replace('id_'+n, {
//easyimage,
/*
media, //need api plugin
imgupload, is only php helper like ajax_upload.php :)

Audio,video,soundPlayer,

*/
				//~ extraPlugins: 'sourcedialog,codemirror',//'removeRedundantNBSP,entities,html5video,html5audio,showprotected,textmatch,autosave,autolink,notification,notificationaggregator,save,codemirror,uploadimage,justify,showblocks,embed,embedbase,embedsemantic,autoembed,lineutils,widgetselection,widget,toolbar<?php echo $extraPlugins ?>',
				extraPlugins: 'codemirror<?php echo !empty($extraPlugins)?','.trim($extraPlugins,','):''; ?>',//'removeRedundantNBSP,entities,html5video,html5audio,showprotected,textmatch,autosave,autolink,notification,notificationaggregator,save,codemirror,uploadimage,justify,showblocks,embed,embedbase,embedsemantic,autoembed,lineutils,widgetselection,widget,toolbar',
				skin: '<?php echo $skin_opt ?>',
				language: '<?php echo $this->lang ?>',
				defaultLanguage: '<?php echo $this->default_lang ?>',
				contentsLanguage: '<?php echo $this->lang ?>',
//				toolbarLocation: 'bottom',
//				toolbarCanCollapse: true,
<?php echo $edit_opt ?>
//				menu_groups: 'clipboard,table,anchor,link,image',
<?php echo $toolbarGroups ?>

//				protectedSource: '/<\?[\s\S]*?\?>/g',//.push( /<\?[\s\S]*?\?>/g ),//no
//				protectedSource.push( /<\?php [\s\S]*?\?>/g ),//no ::: SyntaxError: missing : after property id
<?php echo $spell_opt ?>
//				BrowserContextMenuOnCtrl: true,//defaut is true
//				enableContextMenu: false,//defaut is true
				shiftEnterMode: CKEDITOR.ENTER_BR,

				<?php echo ($height?$height:"height:(textareas[i].offsetHeight?textareas[i].offsetHeight:222)+'px',") ?>
//				scayt_autoStartup: true,
				//embed_provider: '//example.com/api/oembed-proxy?resource-url={url}&callback={callback}',
//~				 embed_provider: 'https://ckeditor.iframe.ly/api/oembed?url={url}&callback={callback}',

				embed_provider: '<?php echo 'http'.(isset($_SERVER['HTTPS'])?'s':'') ?>://noembed.com/embed?url={url}&callback={callback}',
				allowedContent: true,
				extraAllowedContent: 'audio[*]{*};video[*]{*}',
//~ 				filebrowserBrowseUrl: roxyFileman,
//~				 filebrowserImageBrowseUrl: roxyFileman+'&type=image',
				filebrowserBrowseUrl: <?php echo __CLASS__ ?>Fileman+'&input='+n,
				filebrowserImageBrowseUrl: <?php echo __CLASS__ ?>Fileman+'&input='+n+'&type=image',
//				removeDialogTabs: 'link:upload;image:upload',
<?php
				$ckid = explode(DIRECTORY_SEPARATOR,$_SERVER['REQUEST_URI']);//
				$ckid = str_replace(array('.php','?','=','&'),'',end($ckid));//
				$ckid .= isset($_POST['new_category']) ? 'a'.@$_GET['a'] : '';//for new cat (in article)
?>
				autosave_SaveKey: '<?php echo __CLASS__ ?>ckautosaveKey_'+i+'_<?php echo $this->lang.'_'.$ckid ?>',
//				autosave_saveDetectionSelectors: "a[href^='javascript:__doPostBack'][id*='Save'],a[id*='Cancel']";
				imageUploadUrl: '<?php echo PLX_PLUGINS.__CLASS__ ?>/ajax_upload.php?type=Images&plx_version=<?php echo @PLX_VERSION ?>',
				entities: false,

//				basicEntities: false, //too bad , I use removeRedundantNBSP plugin & work fine : stackoverflow.com/a/27818172

//				contentsCss: '/css/mysitestyles.css',
//				contentsCss: [ '/css/mysitestyles.css', '/css/anotherfile.css' ],
/**/
				codemirror:{
					// Set this to the theme you wish to use (codemirror themes)
					theme: '<?php echo $this->getParam('cmtheme') ?>',//default, abcdef, solarized...
					lineNumbers: true,// Whether or not you want to show line numbers
					lineWrapping: true,// Whether or not you want to use line wrapping
					matchBrackets: true,// Whether or not you want to highlight matching braces
					autoCloseTags: true,// Whether or not you want tags to automatically close themselves
					autoCloseBrackets: true,// Whether or not you want Brackets to automatically close themselves
					enableSearchTools: true,// Whether or not to enable search tools, CTRL+F (Find), CTRL+SHIFT+F (Replace), CTRL+SHIFT+R (Replace All), CTRL+G (Find Next), CTRL+SHIFT+G (Find Previous)
					enableCodeFolding: true,// Whether or not you wish to enable code folding (requires 'lineNumbers' to be set to 'true')
					enableCodeFormatting: true,// Whether or not to enable code formatting
					autoFormatOnStart: true,// Whether or not to automatically format code should be done when the editor is loaded
					autoFormatOnModeChange: true,// Whether or not to automatically format code should be done every time the source view is opened
					autoFormatOnUncomment: true,// Whether or not to automatically format code which has just been uncommented
//					mode: 'application/x-httpd-php',// Define the language specific mode 'htmlmixed' for html including (css, xml, javascript), 'application/x-httpd-php' for php mode including html, or 'text/javascript' for using java script only #OLD
<?php if($mode=='statique' OR $mode=='parametres_edittpl'): //https://github.com/w8tcha/CKEditor-CodeMirror-Plugin/issues/152#issuecomment-489885692 ?>
					mode: 'application/x-httpd-php',// { name: 'application/x-httpd-php', globalVars: true },
<?php else: ?>
					mode: { name: 'htmlmixed', globalVars: true },
<?php endif; ?>
					showSearchButton: true,// Whether or not to show the search Code button on the toolbar
					showTrailingSpace: true,// Whether or not to show Trailing Spaces
					highlightMatches: true,// Whether or not to highlight all matches of current word/selection
					showFormatButton: true,// Whether or not to show the format button on the toolbar
					showCommentButton: true,// Whether or not to show the comment button on the toolbar
					showUncommentButton: true,// Whether or not to show the uncomment button on the toolbar
					showAutoCompleteButton: true,// Whether or not to show the showAutoCompleteButton button on the toolbar
					styleActiveLine: true// Whether or not to highlight the currently active line
				},

			})//.then(function(editors) {// Méthode qui ajoute le toggle switch;

<?php if($mode=='statique' OR $mode=='parametres_edittpl'): ?>
			editor[i].config.protectedSource.push( /<\?[\s\S]*?\?>/g );//yep² /<\?php [\s\S]*?\?>/g
<?php endif; ?>
			// The "change" event is fired whenever a change is made in the editor.
			editor[i].on( 'change', function( evt ) {
				if(is_modified) return;
				is_modified = 1;
				// getData() returns CKEditor's HTML content.
				//console.log( 'Total bytes: ' + evt.editor.getData().length );
				if (typeof plxAdminBar_fields_is_modified === "function") {// safe to use the function //duckduckgo.com/?q=js+test+if+function+exist&t=ffsb&ia=web
					plxAdminBar_fields_is_modified();// Compatibility plugin plxAdminBar >= v2.1.0 : set : plx_fields_is_modified = 1;
				}
			});
/*
			editor[i].on( 'preview', function( evt ) {//uncalled
				console.log('preview callBack',evt);
				var preview = document.getElementsByName("preview");// article
				if(preview) {preview.click(); return;}// article
				evt.preview();//?
			});
*/
//~ editor[i].fire( 'save' )
			editor[i].on( 'save', function( evt ) {
//Fix : on save normal event call (button)
//				console.log('save callBack');
				var save_forms = document.getElementsByName("update");// article
				if(!save_forms[0])
					save_forms = document.getElementsByName("draft");// article
					if(!save_forms[0]){
						var inputs = document.getElementsByTagName('input');// other
						for (var i = 0; i < inputs.length; i++) {
							if (inputs[i].getAttribute('type') == 'submit') {
								inputs[i].click();
								return;
							}
						}
					}
				save_forms[0].click();
			});
<?php
/* js  unsused

//toggle tep c4
//duckduckgo.com/?q=toggle+ckeditor4&t=ffab&ia=web
//https://origin-docs.ckeditor.com/ckeditor4/docs/#!/api/CKEDITOR.command
//https://ckeditor.com/old/forums/CKEditor-3.x/Toggle
/* c3
function toggleCKedit() {
if (ck) {
ck.destroy();
ck = false;
}else{
ck = CKEDITOR.replace(document.getElementById('id');
}
}
*/
?>
if(!taid){//1st time init
//console.log(editor id: '+editors[ed].id);
// v4.x toggle editor https://stackoverflow.com/a/30664473 	tinymce.EditorManager.execCommand('mceToggleEditor', true, editors[ed].id);//disable editor on launch
			var tog = document.createElement('div');
			var gle = textareas[i];//document.getElementById('id_'+n);// xahlee.info/js/js_insert_after.html
			tog.innerHTML = '<a href="javascript:;" onclick="ckToggleEditor(\''+textareas[i].id+'\');"><img title="<?php $this->lang('L_TOGGLE') ?>" alt="[Off/On CKEditor]" style="vertical-align:middle;margin-left:4px;" src="<?php echo PLX_PLUGINS.__CLASS__; ?>/img/toggle.png" /><?php $this->lang('L_TOGGLE') ?></a>';// linuxmint icon shutdown sys ;)
//   console.log('gle',gle,'id_'+n);
//			gle.parentNode.insertBefore(tog, gle.nextSibling);// add after existing node (textareas)
			gle.parentNode.insertBefore(tog, gle);// add before existing node (textareas)
}
<?php
/* js  unsused

//console.log(editor id: '+editors[ed].id);
// v4.x toggle editor https://stackoverflow.com/a/30664473 	tinymce.EditorManager.execCommand('mceToggleEditor', true, editors[ed].id);//disable editor on launch
			var tog = document.createElement('div');
			var gle = document.getElementById(editors[ed].id);// xahlee.info/js/js_insert_after.html
			tog.innerHTML = '<a href="javascript:;" onclick="tinymce.execCommand(\'mceToggleEditor\', true, \''+editors[ed].id+'\');"><img title="<?php $this->lang('L_TOGGLE') ?>" alt="[Off/On Tiny]" style="vertical-align:middle;margin-left:4px;" src="<?php echo PLX_PLUGINS.__CLASS__; ?>/img/toggle.png" /><?php $this->lang('L_TOGGLE') ?></a>';// linuxmint icon shutdown sys ;)
//			gle.parentNode.insertBefore(tog, gle.nextSibling);// add after existing node (textareas)
			gle.parentNode.insertBefore(tog, gle);// add before existing node (textareas)

*/
?>
		}//fi n=="content" || n=="chapo"
	}//for/textareas
}

ckeInit();//init all (1st time)
<?php
/* js  unsused
//stackoverflow.com/a/35052777 //stackoverflow.com/questions/35037173/how-to-get-the-save-event-in-ckeditor-editor
CKEDITOR.plugins.registered['save'] = {
	init: function (editor) {
		var command = editor.addCommand('save',
		{
			modes: { wysiwyg: 1, source: 1 },
			exec: function (editor) {
			//alert('You clicked the save button in CKEditor toolbar!');
//Fix : on save normal event call (button)
//			console.log('save callBack');
			var save_forms = document.getElementsByName("update");// article
			if(!save_forms[0])
				save_forms = document.getElementsByName("draft");// article
				if(!save_forms[0]){
					var inputs = document.getElementsByTagName('input');// other
					for (var i = 0; i < inputs.length; i++) {
						if (inputs[i].getAttribute('type') == 'submit') {
							inputs[i].click();
							return;
						}
					}
				}
			save_forms[0].click();
			}
		});
		editor.ui.addButton('Save', { label: 'Save', command: 'save' });
	}
}
*/

?>
//Fix : on save normal event call (button)
	var inputs = document.getElementsByTagName('input');//
	for (var j = 0; j < inputs.length; j++) {
		if (inputs[j].getAttribute('type') == 'submit') {//console.log(inputs[j].name,inputs[j].onclick);
			if(inputs[j].name != 'delete' && inputs[j].name != 'preview')
				inputs[j].onclick = function (ev){this.form.target = '_self';is_modified = 0;return true;};
		}
	}
 /* #BEP BUGGY
 	for (var j = 0; j < inputs.length; j++) {
		if (inputs[j].getAttribute('type') == 'submit') {
//			var oc = inputs[j].onclick;//inputs[j].getAttribute('onclick');//chained onClick fix inputs[j].name == 'delete' onclick not display alert
//   console.log(inputs[j].name,inputs[j].getAttribute('onclick'));
			if(inputs[j].name != 'delete' && inputs[j].name != 'preview')
				inputs[j].onclick = function (ev){inputs[j].onclick();is_modified = 0;return false;};
				//~ inputs[j].onclick = function (ev){this.form.target = '_self';is_modified = 0;return true;};
				//~ inputs[j].onclick = function (ev){inputs[j].onclick();is_modified = 0;return false;};
		}
	}
 */
	window.onbeforeunload = function (ev){
<?php
/* js  unsused
		//~ console.log('ck onbeforeunload',ev);
		//~ console.log('ck onbeforeunload',ev.target.activeElement.tagName: "IFRAME");
/*
//		console.log('ck onbeforeunload',ev.target.activeElement.tagName);
		if (ev.target.activeElement.tagName=="IFRAME")//save btn #tep
			is_modified = 0;
*/
?>
		if (is_modified)
			return "Your change has not been sent or saved, and will be lost if you leave this page.";
	}
<?php
/* js  unsused
//ckeditor.com/old/comment/42869
//duckduckgo.com/?q=toggle+ckeditor&t=ffab&ia=web
// click the edit button to toogle views
$('#edit').on('click', function() {

  // if there is an existing instance of this editor
  if (CKEDITOR.instances.txt_area) {
    // destroying instance
    CKEDITOR.instances.txt_area.destroy();
  } else {
    // re-creating instance
    CKEDITOR.replace('txt_area');
  }

});
*/
?>
}//fi CKEDITOR !undefined
</script>
<?php
	}

	/**
	 * Méthode qui remplace les "myserver/data/media" par "data/media" a l'enregistrement
	 * @author	Thomas Ingles
	 **/
#enregitrer plxAdminEditArticle #wymeditor.1.1.5 idea+++
	public function urls2Root(){#Méthode qui convertit les liens absolus en liens relatifs pour les medias, images et les documents
echo '<?php '; ?>
	$d = '="';
	$s = "='";
	$o = '<input class="remove-videodetector" type="button" value="Remove video" />';//2nd tool oembed fix : videodetector
	$e = '';
	if(isset($this->aConf['medias'])){// plx.5.4+
		$c = array($d.$this->racine.$this->aConf['medias'],$s.$this->racine.$this->aConf['medias'],$o);
		$r = array($d.$this->aConf['medias'],$s.$this->aConf['medias'],$e);
	}else{
		$c = array($d.$this->racine.$this->aConf['images'],$s.$this->racine.$this->aConf['images'],$d.$this->racine.$this->aConf['documents'],$s.$this->racine.$this->aConf['documents'],$o);
		$r = array($d.$this->aConf['images'],$s.$this->aConf['images'],$d.$this->aConf['documents'],$s.$this->aConf['documents'],$e);
	}
	if(isset($content)){//article
		if(isset($content['chapo'])){//plxAdminEditArticle article.php
			$content['chapo'] = str_replace($c,$r,$content['chapo']);
			$content['content'] = str_replace($c,$r,$content['content']);
		}elseif(isset($content['content'])){

//htmlspecialchars($str,ENT_QUOTES,PLX_CHARSET);

			$content['content'] = str_replace($c,$r,$content['content']);//plxMotorAddCommentaire + plxAdminEditStatique static.php
			$this->aUsers[$_SESSION['user']]['infos'] = $content['content'];//plxAdminEditProfil profil.php
		}elseif(isset($content['feed_footer'])){
			$content['feed_footer'] = str_replace($c,$r,$content['feed_footer']);//plxAdminEditConfiguration parametres_affichage.php
		}
	}
?><?php
 }

	/**
	 * Méthode qui ajoute la racine aux liens pour que les images soient visibles dans l'éditeur (maybe see ckeswd ;)
	 *
	 * @return	stdio
	 * @author	Thomas Ingles
	 **/
#Afficher Admin[Article|Categorie|Statique|Commentaire|Profil|User|Configuration](Top) : AdminArticleTop #wymeditor.1.1.5 idea+++
	public function toRoot(){#Méthode qui convertit les liens relatifs en liens absolus pour l'affichage dans ck des medias, images et documents
echo '<?php '; ?>
	$d = '="';
	$s = "='";
	if(isset($plxAdmin->aConf['medias'])){// plx.5.4+
		$c = array($d.$plxAdmin->aConf['medias'],$s.$plxAdmin->aConf['medias']);
		$r = array($d.$plxAdmin->racine.$plxAdmin->aConf['medias'],$s.$plxAdmin->racine.$plxAdmin->aConf['medias']);
	}else{
		$c = array($d.$plxAdmin->aConf['images'],$s.$plxAdmin->aConf['images'],$d.$plxAdmin->aConf['documents'],$s.$plxAdmin->aConf['documents']);
		$r = array($d.$plxAdmin->racine.$plxAdmin->aConf['images'],$s.$plxAdmin->racine.$plxAdmin->aConf['images'],$d.$plxAdmin->racine.$plxAdmin->aConf['documents'],$s.$plxAdmin->racine.$plxAdmin->aConf['documents']);
	}
	if(isset($chapo))$chapo = str_replace($c,$r,$chapo);
	if(isset($content) AND is_string($content))$content = str_replace($c,$r,$content);
	if(isset($_profil))$_profil['infos'] = str_replace($c,$r,$_profil['infos']);//profil.php
	if(isset($id) AND isset($plxAdmin->aUsers[$id]['infos'])) $plxAdmin->aUsers[$id]['infos'] = str_replace($c,$r,$plxAdmin->aUsers[$id]['infos']);//user.php FIX Notice: Undefined variable: id in core/admin/article.php(320) : eval()'d code

	if(isset($plxAdmin->aConf['feed_footer'])) $plxAdmin->aConf['feed_footer'] = str_replace($c,$r,$plxAdmin->aConf['feed_footer']);// AdminSettingsDisplayTop : parametres_affichage.php

?><?php
	}
}
